/**/

call value 'RXCANON', '', 'DOSENVIRONMENT'
call TEST
say 'test with TRUENAME - press any key' ; call GETKEY
call value 'RXCANON', 1, 'DOSENVIRONMENT'
call TEST
say 'test with RXCANON - press any key' ; call GETKEY
exit

TEST: procedure
say '+        =' TRUENAME( '+' )
say '. .      =' TRUENAME( '. .' )
say 'z:\zz    =' TRUENAME( 'z:\zz' )
say '.\.\.    =' TRUENAME( '.\.\.' )
say '.\nul    =' TRUENAME( '.\nul' )
say 'x\y\z    =' TRUENAME( 'x\y\z' )
say 'aO    =' TRUENAME( 'aO' )
say '\dev\nul =' TRUENAME( '\dev\nul' )
say 'C:\NUL   =' TRUENAME( 'C:\NUL' )
say 'C:/NUL   =' TRUENAME( 'C:/NUL' )
say '\nul     =' TRUENAME( '\nul' )
say '/nul     =' TRUENAME( '/nul' )
say 'nul      =' TRUENAME( 'nul' )
say '/dev/nul =' TRUENAME( '/dev/nul' )
say '\1       =' TRUENAME( '\1' )
say '\\2      =' TRUENAME( '\\2' )
say '//2      =' TRUENAME( '//2' )
say '\\\3     =' TRUENAME( '\\\3' )
return

DELETE: procedure               /********************************/
   parse version 1 SYS 5 SAA .
   if      SYS = 'KEXX' then do /* Mansfield KEDIT, an editor   */
      'erase' arg(1) ; return rc <> 0
   end
   else if SAA = '/Personal'    /* Quercus PREXX (DOS or OS/2)  */
      then    return dosdel( arg(1) ) = 0
   else if SAA = 'SAA' then do  /* IBM SAA REXX implementations */
      parse source SYS .
      if SYS = 'DOS'
         then return rxdelete( arg(1) ) <> 0         /* DOS  */
      if SYS = 'OS/2' & RxFuncQuery( 'SysFileDelete' )
         then return SysFileDelete( arg(1) ) <> 0    /* OS/2 */
   end
                                /* BREXX, Regina, who knows...  */
   'erase' arg(1) ; return rc <> 0                      /* ???? */

GETENV: procedure               /********************************/
   parse version 1 SYS 5 SAA .
   if      SYS = 'KEXX'         /* Mansfield KEDIT, an editor   */
      then    return dosenv( arg(1) )
   else if SAA = '/Personal'    /* Quercus PREXX (DOS or OS/2)  */
      then    return dosenv( arg(1) )
   else if SAA = 'SAA' then do  /* IBM SAA REXX implementations */
      parse source SYS .
      if SYS = 'DOS'                                    /* DOS  */
         then return value( arg(1),, 'DOSENVIRONMENT' )
      if SYS = 'OS/2'                                   /* OS/2 */
         then return value( arg(1),, 'OS2ENVIRONMENT' )
   end
                                /* BREXX, Regina, who knows...  */
   return value( arg(1),, 'ENVIRONMENT' )               /* ???? */

GETKEY: procedure               /********************************/
   parse version 1 SYS 5 SAA .
   if      SYS = 'KEXX' then do /* Mansfield KEDIT, an editor   */
      'readv key' ; return READV.2
   end
   else if SAA = '/Personal'    /* Quercus PREXX (DOS or OS/2)  */
      then    return inkey()
   else if SAA = 'SAA' then do  /* IBM SAA REXX implementations */
      parse source SYS .
      if SYS = 'DOS'                                    /* DOS  */
         then return rxgetkey(  'noecho' )
      if SYS = 'OS/2' & RxFuncQuery( 'SysGetKey' )      /* OS/2 */
         then return SysGetKey( 'noecho' )
   end
                                /* BREXX, Regina, who knows...  */
   return charin()                                      /* ???? */

TRUENAME: procedure             /********************************/
   parse version 1 NAME 5 .
   TRUENAME = GETENV( 'TMP' ) || '\truename.tmp'

   if NAME = 'KEXX' then do     /* Mansfield KEDIT, an editor   */
      if words( arg(1) ) <> 1 then return ''
      'dosq truename' translate( arg(1), '\', '/' ) '>' TRUENAME
      'kedit' TRUENAME '(noprofile'
      if rc <> 0 then return ''
      'locate :2' ; NAME = curline.3() ; 'qquit'
   end
   else if GETENV( 'RXCANON' ) = '1' then return RXCANON( arg(1) )
   else do
      if words( arg(1) ) <> 1 then return ''
      'truename' translate( arg(1), '\', '/' ) '>' TRUENAME
      call linein    TRUENAME
      NAME = linein( TRUENAME )
      call lineout   TRUENAME
   end

   call DELETE  TRUENAME
   return NAME
